package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;
import java.util.Optional;

import com.rjconsultores.ventaboletos.dao.EmpresaCieloLinkDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaCieloLinkConfig;
import com.rjconsultores.ventaboletos.service.EmpresaCieloLinkService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service("empresaCieloLinkService")
public class EmpresaCieloLinkServiceImpl implements EmpresaCieloLinkService {

	@Autowired
	private EmpresaCieloLinkDAO empresaCieloLinkService;

	@Override
	public List<EmpresaCieloLinkConfig> obtenerTodos() {
		return empresaCieloLinkService.obtenerTodos();
	}

	@Override
	public EmpresaCieloLinkConfig obtenerID(Integer id) {
		return empresaCieloLinkService.obtenerID(id);
	}

	@Override
	@Transactional
	public EmpresaCieloLinkConfig suscribir(EmpresaCieloLinkConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaCieloLinkService.suscribir(entidad);
	}

	@Override
	@Transactional
	public EmpresaCieloLinkConfig actualizacion(EmpresaCieloLinkConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaCieloLinkService.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(EmpresaCieloLinkConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		empresaCieloLinkService.actualizacion(entidad);

	}

	@Override
	public Optional<EmpresaCieloLinkConfig> buscarPorEmpresa(Empresa empresa) {
		return empresaCieloLinkService.buscarPorEmpresa(empresa);
	}

}
